package solutions.bitbadger.documents.scala

import org.scalatest.funspec.AnyFunSpec
import org.scalatest.matchers.should.Matchers
import solutions.bitbadger.documents.{Dialect, DocumentException}

class DialectSpec extends AnyFunSpec with Matchers {

  describe("deriveFromConnectionString") {
    it("derives PostgreSQL correctly") {
      Dialect.deriveFromConnectionString("jdbc:postgresql:db") shouldEqual Dialect.POSTGRESQL
    }
    it("derives SQLite correctly") {
      Dialect.deriveFromConnectionString("jdbc:sqlite:memory") shouldEqual Dialect.SQLITE
    }
    it("fails when the connection string is unknown") {
      try {
        Dialect.deriveFromConnectionString("SQL Server")
        fail("Dialect derivation should have failed")
      } catch {
        case ex: DocumentException =>
          ex.getMessage should not be null
          ex.getMessage should include ("[SQL Server]")
      }
    }
  }
}
